﻿// Nummerierung
// Setzt vor die markierten Absätze einen verankerten Rahmen
// und fügt eine Nummerierung ein

// Um einen Tastaturbefehl für ein Skript hinzuzufügen, 
// wählen Sie Bearbeiten > Tastaturbefehle, markieren Sie einen änderbaren Tastaturbefehlssatz 
// im Menü Satz und wählen Sie Skripten aus dem Menü Produktbereich aus. Eine Liste der Skripten 
// in Ihrer Skripten-Palette wird angezeigt.

//// KONFIGURATION ///

// Breite / Hoehe der Box
var hoeheInlineFrame = 6.7;
var breiteInlineFrame = 5.2;

// Positionierung Box

var versatzY = 1.1; // positive Werte verschieben nach unten, negative nach oben
//var versatzX = -5; //

// Konturenführung angeben

var myOffset = new Array();

		myOffsetTop = 0;
		myOffsetLeft = 0;
		myOffsetBottom = -1;
		myOffsetRight = 0;

// Ende Konfiguration

myOffset = [myOffsetTop, myOffsetLeft, myOffsetBottom, myOffsetRight]

//var konturenFuehrungRechts = 0;
//var konturenFuehrungUnten = 0;


Object.prototype.isText = function() { 
  switch(this.constructor.name){ 
    case "InsertionPoint": 
    case "Character": 
    case "Word": 
    case "Paragraph": 
    case "Text": 
	 case "TextColumn":
	 case "TextStyleRange":
      return true; 
      default : 
      return false; 
  } 
} 

app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll; 

if (app.documents.length !=0)  {	
	
var myDoc = app.activeDocument;

		var myDialog = app.dialogs.add({name:"Absatz Nummerierung"});
			with(myDialog.dialogColumns.add()){
				with(dialogRows.add()){
					staticTexts.add({staticLabel:"Wollen Sie diesen Absatz wirklich formatieren" });
				}
				with(dialogRows.add()){
					staticTexts.add({staticLabel:"und Nummerierung hinzufügen?"});		
				}
				
			}
				
			var myResult = myDialog.show();
			
			if(myResult == true){
						
				var noetigeAbsatzformate = new Array();
				var noetigeZeichenformate = new Array();
				
				var meinInhalt = null;

				mySel = app.selection[0];

				if (typeof mySel == "undefined") { errorExit("Bitte platzieren Sie den Cursor in einem Absatz, bevor Sie das Skript ausführen.") }

				if (!mySel.isText()) { errorExit("Bitte platzieren Sie den Cursor in einem Absatz, bevor Sie das Skript ausführen.") } 

				
							myParagraphs = mySel.paragraphs;
							try {
							
							// alle Absätze durchlaufen
							
							for (var i = myParagraphs.length-1; i >= 0; i--)
							{	
							
							meinParagraph = myParagraphs.item(i);
							
							myMakeSideHead(meinParagraph,i);
							
							}

								} // Ende Try
						catch(myError){
						alert("Fehler beim Formatieren" + "\r" + "Absatz enthält keinen Text. Bitte wählen Sie einen Absatz mit mindestens einem Wort aus.");
						exit();
						}


	
			
				}	
							
			else{
				myDialog.destroy();
			}
			
} // Ende ist Dok offen

else{
		alert(unescape("Kein Dokument ge%F6ffnet. Bitte erst ein Dokument %F6ffnen."));
	}

function errorExit(message) { 
  if (arguments.length > 0) { 
    if (app.version != 3) { beep() }
    alert(message); 
  } 
  exit(); 
} 

function myMakeSideHead(myParagraph, zaehler){ 
  
  var myInlineFrame = myParagraph.insertionPoints.item(0).textFrames.add(); 

	var myY1 = myInlineFrame.geometricBounds[0] + versatzY; 
	var myX1 = myInlineFrame.geometricBounds[1]; // + versatzX; 
	var myY2 = myY1 + hoeheInlineFrame; // ist oben konfigurierbar
	var myX2 = myX1 + breiteInlineFrame; // ist oben konfigurierbar

myInlineFrame.geometricBounds = [myY1, myX1, myY2, myX2];
myInlineFrame.contentType = ContentType.textType
myInlineFrame.contents = String(zaehler + 1); 
myInlineFrame.paragraphs.item(0).appliedParagraphStyle = app.activeDocument.paragraphStyles.item('myNumber');

// Konturenführung hinzufügen
myInlineFrame.textWrapPreferences.textWrapType = TextWrapTypes.boundingBoxTextWrap;

myInlineFrame.textWrapPreferences.textWrapOffset = myOffset;



}